{% extends 'layout.html.twig' %}

{% block title %}{{ member.displayMemberNumber }} - {{ site_name }}{% endblock %}

{% block breadcrumbs %}
<a href="{{ path('homepage') }}"><i class="material-icons">home</i></a><i class="material-icons">chevron_right</i>
{% if is_granted("ROLE_ADMIN") %}
    <a href="{{ path('admin') }}"><i class="material-icons">build</i>&nbsp;Administration</a><i class="material-icons">chevron_right</i>
    <a href="{{ path('user_index') }}"><i class="material-icons">people</i>&nbsp;Liste des membres</a><i class="material-icons">chevron_right</i>
{% else %}
    <a href="{{ path('user_office_tools') }}"><i class="material-icons">folder_shared</i>&nbsp;Adhésion et ré-adhésion</a><i class="material-icons">chevron_right</i>
{% endif %}
<i class="material-icons">person</i>&nbsp;{{ member.displayMemberNumber }}
{% endblock %}

{% block content %}
    <h4>
        {% if member.withdrawn %}<del>{% endif %}
        Membre #{{ member.memberNumber }}{% if member.withdrawn %}</del>{% endif %}
        {% include "admin/member/_partial/status_icons.html.twig" with { member: member } %}
    </h4>

    <!-- Détails sur le(s) bénéficiaire(s) -->
    {% if member.beneficiaries | length %}
        <div class="row">
            {% for beneficiary in member.beneficiariesWithMainInFirstPosition %}
                {% include "beneficiary/_partial/beneficiary_card.html.twig" with { beneficiary: beneficiary, detach_form: detach_beneficiary_forms[beneficiary.id], delete_form: delete_beneficiary_forms[beneficiary.id] } %}
            {% endfor %}
        </div>
    {% endif %}

    <!-- Ajouter un bénéficiaire -->
    {% if is_granted("beneficiary_add", member) and member.beneficiaries | length < maximum_nb_of_beneficiaries_in_membership %}
        <ul class="collapsible">
            <li>
                <div class="collapsible-header"><i class="material-icons">person_add</i>Ajouter un bénéficiaire</div>
                <div class="collapsible-body white new_registration_form">
                    {{ form_start(new_beneficiary_form) }}
                    {% include "beneficiary/_partial/beneficiary_form.html.twig" with { form: new_beneficiary_form } %}
                    <div class="col s3">
                        <button type="submit" class="btn"><i class="material-icons left">add</i>Ajouter</button>
                    </div>
                    {{ form_end(new_beneficiary_form) }}
                </div>
            </li>
        </ul>
    {% endif %}

    <ul class="collapsible collapsible-expandable">
        <!-- Adhésion(s) -->
        <li id="registration">
            <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.registration_open is defined and frontend_cookie.user_show.registration_open %}active{% endif %}">
                <i class="material-icons">card_membership</i>Adhésions
                {% if member.registrations | length == 0 %}
                    <span style="margin-left:14px;">⚠️</span>
                {% endif %}
            </div>
            <div class="collapsible-body white">
                {% include "member/_partial/registrations.html.twig" with { member: member, from_admin: true, new_registration_form: new_registration_form } %}
            </div>
        </li>

        <!-- Notes -->
        <li id="note">
            <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.note_open is defined and frontend_cookie.user_show.note_open %}active{% endif %}">
                <i class="material-icons">chat_bubble_outline</i>Notes
                {% if member.notes | length > 0 %}
                    <span class="badge teal white-text" style="margin-left:14px;">{{ member.notes | length }}</span>
                {% endif %}
            </div>
            <div class="collapsible-body white">
                {% include "member/_partial/notes.html.twig"  with { member: member, note: note, note_form: note_form, notes_form: notes_form, note_delete_forms: note_delete_forms, new_notes_form: new_notes_form } %}
            </div>
        </li>

        <!-- Compteur de temps -->
        <li id="time_log">
            <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.time_log_open is defined and frontend_cookie.user_show.time_log_open %}active{% endif %}">
                <i class="material-icons">access_time</i>Compteur de temps
            </div>
            <div class="collapsible-body white">
                {% include "member/_partial/time_logs.html.twig" with { member: member, from_admin: true, time_log_new_form: time_log_new_form, time_log_delete_forms: time_log_delete_forms } %}
            </div>
        </li>

        <!-- Créneaux -->
        <li id="shifts">
            <div class="collapsible-header {% if frontend_cookie and frontend_cookie.shifts_show is defined and frontend_cookie.user_show.shifts_open is defined and frontend_cookie.user_show.shifts_open %}active{% endif %}">
                <i class="material-icons">date_range</i>Créneaux
                {% if not member.firstShiftDate %}
                    <span style="margin-left:14px;">⚠️</span>
                {% endif %}
            </div>
            <div class="collapsible-body white">
                {% include "member/_partial/shifts.html.twig" %}
            </div>
        </li>

        <!-- Créneaux annulés -->
        {% if admin_member_display_shift_free_log %}
            <li id="shiftfreelogs">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.shiftfreelogs_show is defined and frontend_cookie.user_show.shifts_open is defined and frontend_cookie.user_show.shiftfreelogs_open %}active{% endif %}">
                    <i class="material-icons">delete_sweep</i>Historique des créneaux annulés
                </div>
                <div class="collapsible-body">
                    {% include "member/_partial/shift_free_logs.html.twig" with { shiftFreeLogs: membership_service.getShiftFreeLogs(member), from_admin: true, custom_styles: "max-height:500px;overflow:scroll;" } %}
                </div>
            </li>
        {% endif %}

        <!-- Postes fixes annulés -->
        {% if use_fly_and_fixed and admin_member_display_period_position_free_log %}
            <li id="periodpositionfreelogs">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.periodpositionfreelogs_show is defined and frontend_cookie.user_show.shifts_open is defined and frontend_cookie.user_show.periodpositionfreelogs_open %}active{% endif %}">
                    <i class="material-icons">delete_sweep</i>Historique des postes fixes annulés
                </div>
                <div class="collapsible-body">
                    {% include "member/_partial/period_position_free_logs.html.twig" with { periodPositionFreeLogs: membership_service.getPeriodPositionFreeLogs(member), from_admin: true, custom_styles: "max-height:500px;overflow:scroll;" } %}
                </div>
            </li>
        {% endif %}

        <!-- Badges -->
        {% if is_granted("ROLE_USER_MANAGER") %}
            <li id="badges">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.badges_open is defined and frontend_cookie.user_show.badges_open %}active{% endif %}">
                    <i class="material-icons">credit_card</i>Badges
                </div>
                <div class="collapsible-body white">
                    {% include "member/_partial/swipe_cards.html.twig" with { member: member } %}
                </div>
            </li>
        {% endif %}

        <!-- Geler/Dégeler le compte -->
        {% if is_granted("ROLE_USER_MANAGER") %}
            <li id="freeze">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.freeze_open is defined and frontend_cookie.user_show.freeze_open %}active{% endif %}">
                    <i class="material-icons">{{ member_frozen_material_icon }}</i>{% if member.frozen %}Dégeler le compte{% else %}Geler le compte{% endif %}
                </div>
                <div class="collapsible-body white">
                    {% if is_granted("freeze_change", member) %}
                        {{ form_start(freeze_change_form) }}
                        {% if not member.frozen %}
                            {% if member.frozenChange %}
                                <button type="submit" class="btn waves-effect waves-light orange">
                                    <i class="material-icons left">cancel</i>Annuler la demande de gel du compte
                                </button>
                            {% else %}
                                <button type="submit" class="btn waves-effect waves-light deep-purple">
                                    <i class="material-icons left">paused</i>Geler le compte à la fin du cycle
                                </button>
                            {% endif %}
                        {% else %}
                            {% if member.frozenChange %}
                                <button type="submit" class="btn waves-effect waves-light orange">
                                    <i class="material-icons left">cancel</i>Annuler la demande de dégel du compte
                                </button>
                            {% else %}
                                <button type="submit" class="btn waves-effect waves-light deep-purple lighten-2">
                                    <i class="material-icons left">play_arrow</i>Dégeler le compte à la fin du cycle
                                </button>
                            {% endif %}
                        {% endif %}
                        {{ form_end(freeze_change_form) }}
                    {% endif %}
                    {% if is_granted("freeze", member) %}
                        {% if not member.frozen %}
                            <a href="#freeze-member-confirmation-modal" class="waves-effect waves-light btn modal-trigger deep-purple lighten-2">
                                <i class="material-icons left">paused</i><i class="material-icons left">timer_off</i>Geler le compte immédiatement
                            </a>
                            {{ form_start(freeze_form) }}
                            <div id="freeze-member-confirmation-modal" class="modal">
                                <div class="modal-content">
                                    <h5>
                                        <i class="material-icons left small">pause_circle_filled</i>Gel immédiat du compte
                                    </h5>
                                    <p>Attention, le gel immédiat sera effectif dès aujourd'hui, interdisant l'accès au magasin.</p>
                                    <p>De plus, à la fin du cycle, les heures effectuées ne seront pas décomptées.</p>
                                    <ul>
                                        {% if use_fly_and_fixed %}
                                            <li>Ce membre a {{ period_positions | length }} créneau{% if period_positions | length > 1 %}x{% endif %} fixe.</li>
                                        {% endif %}
                                        <li>Ce membre a {{ in_progress_and_upcoming_shifts | length }} créneau{% if in_progress_and_upcoming_shifts | length > 1 %}x{% endif %} réservé à venir.</li>
                                    </ul>
                                </div>
                                <div class="modal-footer">
                                    <a href="#!" class="modal-action modal-close waves-effect waves-green btn-flat green-text">Retour à la raison</a>
                                    <button type="submit" class="btn waves-effect waves-light orange">
                                        <i class="material-icons left">check</i>Je sais ce que je fais !
                                    </button>
                                </div>
                            </div>
                            {{ form_end(freeze_form) }}
                        {% else %}
                            <a href="#unfreeze-member-confirmation-modal" class="waves-effect waves-light btn modal-trigger purple lighten-3">
                                <i class="material-icons left">play_arrow</i><i class="material-icons left">timer_off</i> Dégeler le compte immédiatement
                            </a>
                            {{ form_start(unfreeze_form) }}
                            <div id="unfreeze-member-confirmation-modal" class="modal">
                                <div class="modal-content">
                                    <h5>
                                        <i class="material-icons left small">play_arrow</i>Dégel immédiat du compte
                                    </h5>
                                    <p>Attention, le dégel immédiat sera effectif dés aujourd'hui, réautorisant l'accès au magasin</p>
                                    <p>De plus, les heures de bénévolat sont dues pour ce cycle.</p>
                                </div>
                                <div class="modal-footer">
                                    <a href="#!" class="modal-action modal-close waves-effect waves-green btn-flat green-text">Retour à la raison</a>
                                    <button type="submit" class="btn waves-effect waves-light orange">
                                        <i class="material-icons left">check</i>Je sais ce que je fais !
                                    </button>
                                </div>
                            </div>
                            {{ form_end(unfreeze_form) }}
                        {% endif %}
                    {% endif %}
                </div>
            </li>
        {% endif %}

        <!-- Fermer le compte -->
        {% if is_granted("ROLE_USER_MANAGER") and is_granted("close",member) %}
            <li id="close">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.close_open is defined and frontend_cookie.user_show.close_open %}active{% endif %}">
                    <i class="material-icons">close</i>{% if member.withdrawn %}Ré-ouvrir le compte{% else %}Fermer le compte{% endif %}
                </div>
                <div class="collapsible-body white">
                    {% if not member.withdrawn %}
                        <a href="#close-member-confirmation-modal" class="modal-trigger waves-effect waves-light btn red">
                            <i class="material-icons left">close</i>Fermer le compte
                        </a>
                        {{ form_start(close_form) }}
                        <div id="close-member-confirmation-modal" class="modal">
                            <div class="modal-content">
                                <h5>
                                    <i class="material-icons left small">remove_circle_outline</i>Fermeture du compte membre
                                </h5>
                                <p>Attention, vous êtes sur le point de fermer le compte du membre.</p>
                                <ul>
                                    {% if use_fly_and_fixed %}
                                        <li>Ce membre a {{ period_positions | length }} créneau{% if period_positions | length > 1 %}x{% endif %} fixe.</li>
                                    {% endif %}
                                    <li>Ce membre a {{ in_progress_and_upcoming_shifts | length }} créneau{% if in_progress_and_upcoming_shifts | length > 1 %}x{% endif %} réservé à venir.</li>
                                </ul>
                            </div>
                            <div class="modal-footer">
                                <a href="#!" class="modal-action modal-close waves-effect waves-green btn-flat green-text">Retour à la raison</a>
                                <button type="submit" class="btn waves-effect waves-light orange">
                                    <i class="material-icons left">check</i>Je sais ce que je fais !
                                </button>
                            </div>
                        </div>
                        {{ form_end(close_form) }}
                    {% else %}
                        {% if member.withdrawnDate %}
                            <p>
                                Compte fermé le <i>{{ member.withdrawnDate | date_fr }}</i>
                                {% if member.withdrawnBy %}
                                    par {% include "admin/member/_partial/member_or_user_link.html.twig" with { user: member.withdrawnBy, target_blank: true } %}.
                                {% endif %}
                            </p>
                        {% endif %}
                        <a href="#open-member-confirmation-modal" class="modal-trigger waves-effect waves-light btn teal">
                            <i class="material-icons left">check</i>Ré-ouvrir le compte
                        </a>
                        {{ form_start(open_form) }}
                        <div id="open-member-confirmation-modal" class="modal">
                            <div class="modal-content">
                                <h5>
                                    <i class="material-icons left small">info_outline</i>Ré-ouverture du compte membre
                                </h5>
                                <p>Attention, vous êtes sur le point de ré-ouvrir le compte du membre.</p>
                            </div>
                            <div class="modal-footer">
                                <a href="#!" class="modal-action modal-close waves-effect waves-green btn-flat green-text">Retour à la raison</a>
                                <button type="submit" class="btn waves-effect waves-light orange">
                                    <i class="material-icons left">check</i>Je sais ce que je fais !
                                </button>
                            </div>
                        </div>
                        {{ form_end(open_form) }}
                    {% endif %}
                </div>
            </li>
        {% endif %}

        <!-- Rôles -->
        {% if is_granted("ROLE_ADMIN") %}
            <li id="super">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.admin_open is defined and frontend_cookie.user_show.admin_open %}active{% endif %}">
                    <i class="material-icons">verified_user</i>Rôles
                </div>
                <div class="collapsible-body white">
                    {% include "member/_partial/roles.html.twig" with { member: member } %}
                </div>
            </li>
        {% endif %}

        <!-- Actions super admin (supprimer le membre ; adhésions enregistrées) -->
        {% if is_granted("ROLE_SUPER_ADMIN") %}
            <li id="super">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.super_admin_open is defined and frontend_cookie.user_show.super_admin_open %}active{% endif %}">
                    <i class="material-icons">build</i>Actions super admin
                </div>
                <div class="collapsible-body white">
                    {{ form_start(delete_form) }}
                    {{ form_widget(delete_form) }}
                    <a href="#delete-member-confirmation-modal" class="modal-trigger btn red">
                        <i class="material-icons left">delete</i>Supprimer le compte
                    </a>
                    <div id="delete-member-confirmation-modal" class="modal">
                        <div class="modal-content">
                            <h5>
                                <i class="material-icons left small">delete</i>Suppression du compte membre
                            </h5>
                            <p>Attention, vous êtes sur le point de <strong>supprimer</strong> le compte du membre.</p>
                            <p>Cette action est <strong>irréversible</strong>.</p>
                            {% if not member.withdrawn %}
                                <p>Le compte de ce membre n'est pas fermé. Ne voulez-vous pas plutôt "Fermer le compte" ?</p>
                            {% endif %}
                        </div>
                        <div class="modal-footer">
                            <a href="#!" class="modal-action modal-close waves-effect waves-green btn-flat green-text">Retour à la raison</a>
                            <button type="submit" class="btn waves-effect waves-light orange">
                                <i class="material-icons left">check</i>Je sais ce que je fais !
                            </button>
                        </div>
                    </div>
                    {{ form_end(delete_form) }}

                    {% include "member/_partial/recorded_registrations.html.twig" %}
                </div>
            </li>
        {% endif %}

        <!-- Informations sur le membre -->
        {% if is_granted("ROLE_USER_MANAGER") %}
            <li id="super">
                <div class="collapsible-header {% if frontend_cookie and frontend_cookie.user_show is defined and frontend_cookie.user_show.admin_open is defined and frontend_cookie.user_show.info_open %}active{% endif %}">
                    <i class="material-icons">info_outline</i>Informations diverses
                </div>
                <div class="collapsible-body white">
                    {% include "member/_partial/info_misc.html.twig" with { member: member } %}
                </div>
            </li>
        {% endif %}
    </ul>
{% endblock %}

{% block javascripts %}
    <script>
        initCollapsible('#registration');
        initCollapsible('#note');
        initCollapsible('#time_log');
        initCollapsible('#shifts');
        initCollapsible('#badges');
        initCollapsible('#freeze');
        initCollapsible('#close');
        initCollapsible('#super');
    </script>
{% endblock %}

{% block stylesheets %}
    <style>
        div.note strong {
            font-weight: bold;
        }

        div.replies {
            padding-left: 15px;
        }

        {% if member.withdrawn %}
        body {
            background-color: {{ member_withdrawn_background_color }};
        }
        {% elseif member.frozen %}
        body {
            background-color: {{ member_frozen_background_color }};
        }
        {% elseif member.isCurrentlyExemptedFromShifts() %}
        body {
            background-color: {{ member_exempted_background_color }};
        }
        {% elseif not member | uptodate %}
        body {
            background-color: {{ member_registration_missing_background_color }};
        }
        {% endif %}
    </style>
{% endblock %}
